<?php
///////////////////////////////////////////////////////////////////////////
require_once 'utils.php';

class Cursor
{

	    private $m_feed;
	    private $m_feed_url;
	    private $m_items_count;
        private $m_last_ref;

    ///////////////////////////////////////////////////////////////////////

    public function __construct($media_url)
    {
        if ($media_url === 'main_menu:fav')
            $this->m_feed_url = 'main_menu:fav';
        else
            HD::decode_user_data($media_url, $media_str, $this->m_feed_url);

        $this->m_items_count = 0;
        $this->m_feed = 0;
        $this->m_last_ref = "";
    }

    private function parse_page($url)
    {
        $api = HOST_API_URL;
        
        $items = array();
		if (preg_match("/myfavourites.aspx/i",$url))
		{
			$referer = 'http://brb.to/myfavourites.aspx?page=favorites';
			$doc = HD::http_get_document_cookie($url, $referer);
			$count_page ="";
			$tmp = explode('<div class="b-pager">', $doc);
				if (count($tmp) > 1)
			$count_page = strstr($tmp[1], '<a class="next-link"', true);
			
			$videos = explode('<div class="b-poster-thin', $doc);
			unset($videos[0]);
			$videos = array_values($videos);

			foreach($videos as $video)
			{	
				
				$tmp = explode('<a href="', $video);
				if (count($tmp) > 1)
				$season_ref = strstr($tmp[1], '"', true);
							
				$tmp = explode("background-image: url('", $video);
				if (count($tmp) > 1)
				$season_image = strstr($tmp[1], "'", true);
				$season_image = str_replace('/6/', '/1/', $season_image);  //Vokir
				$season_image = str_replace('/9/', '/1/', $season_image);  //Vokir
				$season_image = str_replace('/13/0', '/1/0', $season_image);
				
				$season_page = "";
				$tmp = explode('class="selected">', $count_page);
				if (count($tmp) > 1)
				$season_page = 'Страница: ' . strstr($tmp[1], '<', true);
				
				$tmp = explode('<span>', $video);
				if (count($tmp) < 2)
					continue;
				$season_title = str_remove_spec(strstr($tmp[1], '</span>', true));
				$season_title = str_replace('<p>', ' ', $season_title);
				$season_title = str_replace('</p>', ' ', $season_title);
				//hd_print("--->>> season_ref: $season_ref");
				//hd_print("--->>> season_title: $season_title");
				//hd_print("--->>> season_image: $season_image");
				
				array_push
				(
					$items,
					HD::encode_user_data
					(
						array
						(
							'video_id' => $season_ref,
							'season_title' => $season_title,
							'season_ref' => $season_ref,
							'season_image' => $season_image,
							'season_page' => $season_page,
							'is_has_new' => false
						)
					)
				);
				++$this->m_items_count;
			}
		}
		elseif (preg_match("/scrollload/i",$url))
		{
			$doc = HD::http_get_document($url);
			$doc = str_replace('\\n', "", $doc);
			$doc = str_replace('\\', "", $doc);
			$count_page ="";
			$tmp = explode('<div class="b-pager">', $doc);
				if (count($tmp) > 1)
			$count_page = strstr($tmp[1], '<a class="next-link"', true);
			
			$videos = explode('<div class="b-poster-section', $doc);
			unset($videos[0]);
			$videos = array_values($videos);

			foreach($videos as $video)
			{	
				
				$tmp = explode('<a class="subject-link" href="', $video);
				if (count($tmp) > 1)
				$season_ref = strstr($tmp[1], '"', true);
							
				$tmp = explode('<img src="', $video);
				if (count($tmp) > 1)
				$season_image = strstr($tmp[1], '"', true);
				$season_image = str_replace('/6/', '/1/', $season_image);  //Vokir
				$season_image = str_replace('/9/', '/1/', $season_image);  //Vokir
				
				$season_page = "";
				$tmp = explode('class="selected">', $count_page);
				if (count($tmp) > 1)
				$season_page = 'Страница: ' . strstr($tmp[1], '<', true);
				
				$ql_page = "";
				$tmp = explode('<b class="b-poster-info">', $video);
				if (count($tmp) > 1)
				$ql_page = strstr($tmp[1], '<b class="num', true);
				$ql_page = str_replace("\n", "", $ql_page);
				$ql_page = str_replace("  ", "", $ql_page);
				$ql_page = str_replace('<b class="quality m-', ' [', $ql_page);
				$ql_page = str_replace('"></b>', ']', $ql_page);
				$ql_page = str_replace(';">', ';"> ', $ql_page);
				$ql_page = strip_tags($ql_page);
				
				$ep_page = "";
				$tmp = explode('<b class="num " title="', $video);
				if (count($tmp) > 1)
				$ep_page = ' ' .strstr($tmp[1], '"', true);
								
				$tmp = explode('alt=\'', $video);
				if (count($tmp) < 2)
					continue;
				$season_title = str_remove_spec(strstr($tmp[1], '\'/>', true));
				$season_title = $season_title . $ql_page . $ep_page;
				// hd_print("--->>> season_ref: $season_ref");
				// hd_print("--->>> season_title: $season_title");
				// hd_print("--->>> season_image: $season_image");
				
				array_push
				(
					$items,
					HD::encode_user_data
					(
						array
						(
							'video_id' => $season_ref,
							'season_title' => $season_title,
							'season_ref' => $season_ref,
							'season_image' => $season_image,
							'season_page' => $season_page,
							'is_has_new' => false
						)
					)
				);
				++$this->m_items_count;
			}
		}
		else
		{		
			$doc = HD::http_get_document($url);
			$count_page ="";
			$tmp = explode('<div class="b-pager">', $doc);
				if (count($tmp) > 1)
			$count_page = strstr($tmp[1], '<a class="next-link"', true);
			
			$videos = explode('<div class="b-poster-section', $doc);
			unset($videos[0]);
			$videos = array_values($videos);

			foreach($videos as $video)
			{	
				
				$tmp = explode('<a class="subject-link" href="', $video);
				if (count($tmp) > 1)
				$season_ref = strstr($tmp[1], '"', true);
							
				$tmp = explode('<img src="', $video);
				if (count($tmp) > 1)
				$season_image = strstr($tmp[1], '"', true);
				$season_image = str_replace('/6/', '/1/', $season_image);  //Vokir
				$season_image = str_replace('/9/', '/1/', $season_image);  //Vokir
				
				$season_page = "";
				$tmp = explode('class="selected">', $count_page);
				if (count($tmp) > 1)
				$season_page = 'Страница: ' . strstr($tmp[1], '<', true);
				
				$ql_page = "";
				$tmp = explode('<b class="b-poster-info">', $video);
				if (count($tmp) > 1)
				$ql_page = strstr($tmp[1], '<b class="num', true);
				$ql_page = str_replace("\n", "", $ql_page);
				$ql_page = str_replace("  ", "", $ql_page);
				$ql_page = str_replace('<b class="quality m-', ' [', $ql_page);
				$ql_page = str_replace('"></b>', ']', $ql_page);
				$ql_page = str_replace(';">', ';"> ', $ql_page);
				$ql_page = strip_tags($ql_page);
				
				$ep_page = "";
				$tmp = explode('<b class="num " title="', $video);
				if (count($tmp) > 1)
				$ep_page = ' ' .strstr($tmp[1], '"', true);
								
				$tmp = explode('alt=\'', $video);
				if (count($tmp) < 2)
					continue;
				$season_title = str_remove_spec(strstr($tmp[1], '\'/>', true));
				$season_title = $season_title . $ql_page . $ep_page;
				// hd_print("--->>> season_ref: $season_ref");
				// hd_print("--->>> season_title: $season_title");
				// hd_print("--->>> season_image: $season_image");
				
				array_push
				(
					$items,
					HD::encode_user_data
					(
						array
						(
							'video_id' => $season_ref,
							'season_title' => $season_title,
							'season_ref' => $season_ref,
							'season_image' => $season_image,
							'season_page' => $season_page,
							'is_has_new' => false
						)
					)
				);
				++$this->m_items_count;
			}
        }
        return $items;
    }
	
	private function parse_page_search($url)
    {
        $api = HOST_API_URL;
        
        $items = array();

        $doc = HD::http_get_document($url);
		$count_page ="";
		$tmp = explode('<div class="b-pager">', $doc);
			if (count($tmp) > 1)
        $count_page = strstr($tmp[1], '<a class="next-link"', true);
		$videos = explode('<td class="image-wrap">', $doc);
		
        unset($videos[0]);
        $videos = array_values($videos);

        foreach($videos as $video)
        {	
			$video = preg_replace('|texts(.*)class="section m-books"|Uis', '', $video);//Vokir
			$video = preg_replace('|games(.*)class="section m-games"|Uis', '', $video);//Vokir
			$tmp = explode('<a href="', $video);
			if (count($tmp) > 1)
            $season_ref = strstr($tmp[1], '"', true);
            
			$season_image = "";          
            $tmp = explode('<img src="', $video);
			if (count($tmp) > 1)
            $season_image = strstr($tmp[1], '"', true);
            $season_image = str_replace('/6/', '/1/', $season_image);  //Vokir
			$season_image = str_replace('/5/', '/1/', $season_image);  //Vokir
			$season_image = str_replace('/9/', '/1/', $season_image);  //Vokir
			
			$season_page = "";
			$tmp = explode('class="selected">', $count_page);
			if (count($tmp) > 1)
            $season_page = 'Страница: ' . strstr($tmp[1], '<', true);
			
			$season_inf = "";
			preg_match_all('/<span class="section m-.*">(.*)</', $video, $tmp);
            $season__inf = $tmp [1][0];

			$tmp = explode('title="', $video);
            if (count($tmp) < 2)
                continue;
            $season_title = str_remove_spec(strstr($tmp[1], '"', true));
            $season_title = "$season_title [$season__inf]";
            // hd_print("--->>> season_ref: $season_ref");
            // hd_print("--->>> season_title: $season_title");
            // hd_print("--->>> season_image: $season_image");
            
            array_push
            (
                $items,
                HD::encode_user_data
                (
                    array
                    (
                        'video_id' => $season_ref,
                        'season_title' => $season_title,
                        'season_ref' => $season_ref,
                        'season_image' => $season_image,
						'season_page' => $season_page,
                        'is_has_new' => false
                    )
                )
            );
            ++$this->m_items_count;
        }
        
        return $items;
    }
	
    private function parse_subcategory()
    {
        //hd_print("--> parse subcategory: started...");
        $subcategory = $this->m_feed_url;
        $ref = $subcategory->subcategory_ref;
        $api = HOST_API_URL;
		if (preg_match("/&GoPage=/i",$ref))
		{
		$tmp = explode('&GoPage=', $ref);
		$refs = $tmp[0];
		$nmr_page = $tmp[1]-1;
		$url = $api . $refs . '&page=' . ($nmr_page + ($this->m_feed ));
		}
		
		elseif (preg_match("/myfavourites.aspx/i",$ref))
		{
		$url = $api . $ref;
        if ($this->m_feed > 0)
			return false;
		}
		elseif (preg_match("/\/ldr/i",$ref))
		{
		$ref = str_replace('/ldr', "", $ref);
		$url = $api . $ref;
        if ($this->m_feed > 0)
		{
			$ref = str_replace('?sort=new&view=list', "", $ref);
			$url = $api . $ref . '?scrollload=1&view=list&start=' . (15 * ($this->m_feed )) . '&length=15';
		}
		}
		else
		{       
        $url = $api . $ref;
        if ($this->m_feed > 0)
		$url = $url . '&page=' . ($this->m_feed );
		}
        return $this->parse_page($url);
    }

    ///////////////////////////////////////////////////////////////////////
    private function parse_search_result($search, $video_poisk)
    {	
		//hd_print("--> parse search result: started... $video_poisk");
        if ($video_poisk == "0")
			{
			$poisk_path ='/video';
			}
		elseif ($video_poisk == "1")
			{
			 $poisk_path ='';
			}
		elseif ($video_poisk == "2")
			{
			$poisk_path ='/audio';
			}
		
		$api = HOST_API_URL;
        $ref = $poisk_path . "/search.aspx?search=$search";
        if ($this->m_feed > 0)
            $ref = $ref . "&page=" . (($this->m_feed + 1)-1);
        
        $url = $api . $ref;

        return $this->parse_page_search($url);
    }
    ///////////////////////////////////////////////////////////////////////

    private function get_next_fav(&$plugin_cookies)
    {
      //  hd_print("--> get favorites: started... $this->m_feed");
        
        $fav_items = isset($plugin_cookies->fav_items) ? $plugin_cookies->fav_items : '';
        
        $ref = "";
        
        $n = 0;
        foreach (ListUtil::string_to_list($fav_items) as $item)
        {
            if ($item == "")
                continue;
            
            if ($n == $this->m_feed)
            {
                $ref = $item;
            }

            ++$n;
            
        }

        if ($ref == "")
            return false;
        
        $items = array();

        $c = VideoCache::get($ref);
        if (!is_null($c))
        {
            array_push
            (
                $items,
                $c
            );

            ++$this->m_items_count;

            return $items;
            
        }

        $api = HOST_API_URL;
        
        $url = $api . $ref;
		$new_view = isset($plugin_cookies->new_view) ? $plugin_cookies->new_view : 1;
		
        if ($new_view ==1)
		{
			$doc = HD::http_get_document($url);
			
			$tmp = strstr($doc, '<div class="l-content  ">');
			$info_block = strstr($tmp, '<div class="b-filelist"></div>', true);
			
			// title
			$tmp = explode('Клипы</b>', $info_block);
			if (count($tmp) > 1)
			{
			$season_title = str_remove_spec(strip_tags(strstr($tmp[1], '</div>', true)));
			$season_title = preg_replace('/\s{2,}/', ' ', $season_title);
			}
			else
			{
			$tmp = explode('<div class="b-tab-item__title-inner">', $info_block);
			$season_title = str_remove_spec(strstr($tmp[1], '</span>', true));
			$season_title = preg_replace('/\s{2,}/', ' ', $season_title);
			$season_title = strip_tags($season_title);
			}
			$count_season ="";
			$tmp = explode('Статус:', $info_block);
				if (count($tmp) > 1)
			{
			$count_page = trim(strip_tags(strstr($tmp[1], '</tr>', true)));
			$count_page = " [$count_page]";
			}
			$season_title = $season_title . $count_page;
			//hd_print("video_title--->>> $season_title");
			
			// image
			$season_image = "";
			$tmp = explode('<img src="', $info_block);
			if (count($tmp) > 1)
			$season_image = str_remove_spec(strstr($tmp[1], '"', true));
			if ($season_image == false)
				{
				$tmp = explode('<link rel="image_src" href="', $doc);
				$season_image = str_remove_spec(strstr($tmp[1], '"', true));
				}
			$season_image = str_replace('/2/', '/1/', $season_image);  //Vokir
			$season_image = str_replace('/6/', '/1/', $season_image);  //Vokir
			$season_image = str_replace('/9/', '/1/', $season_image);  //Vokir
		}
        else
		{
			$vid_fav = "fav_links&". $ref;
			if (isset($plugin_cookies->$vid_fav))
						{
						$tmp = explode('*', $plugin_cookies->$vid_fav);
						$season_title = $tmp[0];
						$season_image = $tmp[1];
						}
			$is_has_new = false;
			if ($season_title == false)
			{
			$doc = HD::http_get_document($url);
			
			$tmp = strstr($doc, '<div class="l-content  ">');
			$info_block = strstr($tmp, '<div class="b-filelist"></div>', true);
			
			// title
			$tmp = explode('Клипы</b>', $info_block);
			if (count($tmp) > 1)
			{
			$season_title = str_remove_spec(strip_tags(strstr($tmp[1], '</div>', true)));
			$season_title = preg_replace('/\s{2,}/', ' ', $season_title);
			}
			else
			{
			$tmp = explode('<div class="b-tab-item__title-inner">', $info_block);
			$season_title = str_remove_spec(strstr($tmp[1], '</span>', true));
			$season_title = preg_replace('/\s{2,}/', ' ', $season_title);
			$season_title = strip_tags($season_title);
			}
			//hd_print("video_title--->>> $season_title");
			
			// image
			$tmp = explode('<img src="', $info_block);
			if (count($tmp) > 1)
			$season_image = str_remove_spec(strstr($tmp[1], '"', true));
			if ($season_image == false)
				{
				$tmp = explode('<link rel="image_src" href="', $doc);
				$season_image = str_remove_spec(strstr($tmp[1], '"', true));
				}
			$season_image = str_replace('/2/', '/1/', $season_image);  //Vokir
			$season_image = str_replace('/6/', '/1/', $season_image);  //Vokir
			$season_image = str_replace('/9/', '/1/', $season_image);  //Vokir
			}
			
        }
        array_push
        (
            $items,
            HD::encode_user_data
            (
                array
                (
                    'video_id' => $ref,
                    'season_title' => $season_title,
                    'season_ref' => $ref,
                    'season_image' => $season_image,
                    'is_has_new' => false
                )
            )
        );

        ++$this->m_items_count;

        return $items;
    }
    ///////////////////////////////////////////////////////////////////////

    public function next_chunk($plugin_cookies)
    {
	    //hd_print("--> next_chunk(): started...");

	    $items = array();

        if ($this->m_feed_url === 'main_menu:fav')
        {
            //hd_print("--> parse favorites: started...");
            
            $items = $this->get_next_fav($plugin_cookies);
            ++$this->m_feed;

            if ($items === false)
                return false;
            
            return count($items) > 0 ? $items : false;
        }
	    if (HD::has_attribute($this->m_feed_url, 'ser_feed'))
	    {
		   // hd_print("--> search: started...");
            
		    $search_text = $this->m_feed_url->ser_feed;
            $video_poisk = isset($plugin_cookies->video_poisk) ? $plugin_cookies->video_poisk : 1;
			$items = $this->parse_search_result($search_text, $video_poisk);
            ++$this->m_feed;
            
		 //hd_print("--> search for: " . $search_text);

            if ($items === false)
                return false;
                
            //hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
	    }
        else if (HD::has_attribute($this->m_feed_url, 'subcategory_ref'))
        {
           $items = $this->parse_subcategory();
            ++$this->m_feed;

            if ($items === false)
                return false;
                
            //hd_print("--> next_chunk(): found " . count($items) . " items.");
            return count($items) > 0 ? $items : false;
        }

        return false;
    }
}

///////////////////////////////////////////////////////////////////////////
?>
